package
{
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxG;
	
	public class Memory extends FlxSprite
	{
		public var tX:Number;
		public var tY:Number;
		public var oX:Number;
		public var oY:Number;
		public var dX:Number;
		public var dY:Number;
		public var player:FlxSprite;
		public var accel:Number;
		public var distraction:Boolean;
		public var inflate:Boolean;
		
		public function Memory(p:FlxSprite, X:Number, Y:Number, towardX:Number, towardY:Number, a:Number, spinner:int, SimpleGraphic:Class=null)
		{
			tX = oX = towardX;
			tY = oY = towardY;
			dX = dY = 1;
			if (spinner % 4 == 1)
				dY = -1;
			if (spinner % 4 == 2)
				dY = dX = -1;
			if (spinner % 4 == 3)
				dX = -1;
			player = p;
			accel = a;
			distraction = true;
			inflate = false;
			
			super(X, Y, SimpleGraphic);
		}
		
		override public function update():void
		{
			if (inflate) {
				this.scale = new FlxPoint(this.scale.x + 1.5, this.scale.y + 1.5);
				tX = oX = FlxG.width / 2;
				tY = oY = FlxG.height / 2;
			} else if (!distraction) {
				tX += Math.random() * 20 * dX;
				//tY += Math.random() * 20 * dY;
				if (Math.abs(tX - oX) > 20)
					dX = dX * -1;
				if (Math.abs(tY - oY) > 30)
					dY = dY * -1;
			}
			var destX:Number = (player.x + tX) / 2;
			var destY:Number = (player.y + tY) / 2;
			x += (destX - x) * accel;
			y += (destY - y) * accel;
			
			super.update();
		}
	}
}