package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	import org.flixel.*;
	
	/*
	
	1. Drug addict
		-goes into withdrawal after ten seconds of no drug
		-ten seconds of withdrawal can't move
	
	2. Bad Clone
		- get x number of clones, they die after ten seconds
		- use their dead bodies to solve puzzles?
	
	3. 
	
	4.
	
	*/
	
	public class PlayState extends FlxState
	{
		public var counter:Number;
		public var counterText:FlxText;
		public var level:FlxTilemap;
		public var player:FlxSprite;
		public var face:FlxSprite;
		public var piece:FlxSprite;
		public var memory:Memory;
		public var locations:Array;
		public var locationIndex:int;
		public var memoryAccel:Number;
		public var score:int;
		//public var scoreDash:FlxSprite;
		public var scoreText0:FlxText;
		public var scoreText1:FlxText;
		public var spinner:Number;
		public var pieceDirection:Number;
		public var switchOne:Boolean;
		public var postSwitchOne:Boolean;
		public var memories:Array;
		public var instruct:Instructions;
		public var clouds:Array;
		public var store:FlxGroup;
		public var storeTitle:FlxText;
		public var heart:FlxSprite;
		public var rainbow:FlxSprite;
		public var taco:FlxSprite;
		public var items:Array;
		public var footer:FlxText;
		public var firstSinkOver:Boolean;
		public var scored:Number;
		
		[Embed(source="../res/mapData.png")] public var ImgMapData:Class;
		[Embed(source="../res/face.png")] public var ImgFace:Class;
		[Embed(source="../res/piece.png")] public var ImgPiece:Class;
		[Embed(source="../res/memory.png")] public var ImgMemory:Class;
		[Embed(source="../res/dude.png")] public var ImgDude:Class;
		[Embed(source="../res/cloud.png")] public var ImgCloud:Class;
		[Embed(source="../res/store.png")] public var ImgStore:Class;
		[Embed(source="../res/heart.png")] public var ImgHeart:Class;
		[Embed(source="../res/rainbow.png")] public var ImgRainbow:Class;
		[Embed(source="../res/taco.png")] public var ImgTaco:Class;
		
		
		override public function create():void
		{
			memoryAccel = 0.04;
			spinner = 0;
			pieceDirection = -1;
			score = 0;
			switchOne = false;
			memories = new Array();
			postSwitchOne = false;
			clouds = new Array();
			firstSinkOver = false;
			scored = 0;
			
			locations = new Array( 
				new FlxPoint( 300, FlxG.height - 45 ), 
				new FlxPoint( 250, FlxG.height - 100 ),
				new FlxPoint( 200, FlxG.height - 150 ),
				new FlxPoint( 150, FlxG.height - 100 ),
				new FlxPoint( 340, FlxG.height - 190 ),
				new FlxPoint( 50, FlxG.height - 100 ),
				new FlxPoint( 50, FlxG.height - 100 ),
				new FlxPoint( 50, FlxG.height - 100 ) );
			locationIndex = 0;
			
			var bitmapData:BitmapData = (new FlxSprite(0, 0, ImgMapData)).framePixels;
			
			FlxG.bgColor = 0xffbdbab4;
			
			level = new FlxTilemap();
			level.loadMap(FlxTilemap.bitmapToCSV(bitmapData), FlxTilemap.ImgAuto, 0, 0, FlxTilemap.AUTO);
			level.x = 0;
			level.y = 0;
			add(level);
			
			player = new FlxSprite(65, FlxG.height - 40);
			player.loadGraphic( ImgDude, true, true, 10, 12 );
			player.frame = 0;
			player.maxVelocity.x = 80;
			player.maxVelocity.y = 200;
			player.drag.x = player.maxVelocity.x * 4;
			player.acceleration.y = 200;
			
			player.addAnimation("run", [0, 1], 10);
			player.addAnimation("stand", [2]);
			player.addAnimation("jump", [3]);
			add(player);
			
			counter = 0;
			
			counterText = new FlxText( 35 , 10, 150 , "0");
			counterText.setFormat(null, 16);
			counterText.color = 0xff000000;
			add( counterText );
			
			face = new FlxSprite(10, 14);
			face.loadGraphic(ImgFace, true, true, 20, 20);
			face.frame = 0;
			add( face );
			
			scoreText1 = new FlxText( 21, 14 + face.height + 3, 50, "0");
			scoreText1.setFormat(null, 16);
			scoreText1.color = 0xff366665;
			add(scoreText1);
			
			scoreText0 = new FlxText( 20, 14 + face.height + 3, 50, "0");
			scoreText0.setFormat(null, 16);
			scoreText0.color = 0xff6BCBCA;
			add(scoreText0);
			
			piece = new FlxSprite(420, FlxG.height - 45, ImgPiece);
			piece.allowCollisions = FlxObject.NONE;
			add( piece );
			
			changePiece();
			
			var retryButton:FlxButton = new FlxButton( FlxG.width - 90, 10, "Reset", onReset );
			retryButton.allowCollisions = FlxObject.NONE;
			add(retryButton);
			
			instruct = new Instructions(FlxG.width / 2 - 100, FlxG.height / 2 - 50, 200, "ARROWS ARE FOR MOVEMENT\nTURQUOISE IS FOR SURVIVAL\nORANGE IS FOR                ");
			instruct.color = 0xff000000;
			instruct.alignment = "center";
			add(instruct);
			
			store = new FlxGroup();
			add ( store );
			
			var storeBg:FlxSprite = new FlxSprite(80, 40, ImgStore);
			storeBg.allowCollisions = FlxObject.NONE;
			store.add(storeBg);
			
			storeTitle = new FlxText(storeBg.x + 15, storeBg.y + 15, 200, "This is life. You have -32 seconds. What would you like to purchase?");
			storeTitle.color = 0xff000000;
			store.add(storeTitle);
			
			heart = new FlxSprite(storeTitle.x, storeTitle.y + 35, ImgHeart);
			heart.allowCollisions = FlxObject.NONE;
			rainbow = new FlxSprite(heart.x, heart.y + 28, ImgRainbow);
			rainbow.allowCollisions = FlxObject.NONE;
			taco = new FlxSprite(rainbow.x, rainbow.y + 28, ImgTaco);
			taco.allowCollisions = FlxObject.NONE;
			
			var heartText:FlxText = new FlxText(heart.x + 30, heart.y + 5, 150, "for negative 18 seconds");
			heartText.color = 0xff000000;
			store.add(heartText);
			var rainbowText:FlxText = new FlxText(rainbow.x + 30, rainbow.y + 5, 150, "for negative 31 seconds");
			rainbowText.color = 0xff000000;
			store.add(rainbowText);
			var tacoText:FlxText = new FlxText(taco.x + 30, taco.y + 5, 150, "for negative 5 seconds");
			tacoText.color = 0xff000000;
			store.add(tacoText);
			
			footer = new FlxText(taco.x, taco.y + 28, 200, "");
			footer.color = 0xff000000;
			store.add(footer);
				
			store.add(heart);
			store.add(rainbow);
			store.add(taco);
			
			items = new Array( heart, rainbow, taco);
			
			store.exists = false;
			
			FlxG.mouse.show();
		}
		
		public function changePiece():void
		{
			/*piece.x = piece.x + 80 * pieceDirection;
			if (piece.x < 8 || piece.x > FlxG.width - 8) {
				pieceDirection = -1 * pieceDirection;
				piece.x = piece.x + 80 * pieceDirection;				
			}*/
			if (score < 5)
				piece.x = FlxG.width - 50 - score * 80 + 50 * (score % 2);
			else
				piece.x = 100 + (score - 5) * 80 - 50 * (score % 2);
			piece.y = FlxG.height - 20 - score * 5 - 50 * (score % 2);
			if (memory != null) {
				memory.frame = 1;
				memory.distraction = false;
				memory.accel = 0.02
			}
			memory = new Memory(player, FlxG.width - 30, 30, piece.x, piece.y, memoryAccel, spinner);
			memory.loadGraphic(ImgMemory, true, true, 12, 12);
			memory.frame = 0;
			memory.immovable = true;
			memories.push(memory);
			add(memory);
			locationIndex += 1;
			//memoryAccel += 0.001;
			spinner += 1;
			piece.exists = true;
		}
		
		public function makeClouds():void
		{
			for (var i:int = 0; i < 10; i++) {
				var cloud:FlxSprite = new FlxSprite( 80 + i * 20, 50 - 20 * (i % 2));
				cloud.loadGraphic(ImgCloud, true, true, 16, 8);
				cloud.frame = 0;
				cloud.allowCollisions = FlxObject.NONE;
				add( cloud );
				clouds.push( cloud );
			}
		}
		
		override public function update():void
		{
			counter += FlxG.elapsed;
			if (switchOne) {
				memory.update();
				if (counter > 3) {
					counter = 0;
					FlxG.bgColor = 0xff6bcbca;
					scoreText0.color = 0xff8B8882;
					scoreText1.color = 0xff000000;
					switchOne = false;
					postSwitchOne = true;
					memory.inflate = false;
					memory.scale = new FlxPoint( 1, 1 );
					instruct.alpha = 1.0;
					instruct.text = "THE EARTH IS NOT FOR GRAVITY\nCLOUDS ARE FOR WATER";
					makeClouds();
					for each (var mem:Memory in memories) {
						mem.frame = 2;
						mem.oX = mem.tX = FlxG.width + Math.random() * 50;
						mem.oY = mem.tY = 0 + Math.random() * 50 - FlxG.height / 2;
						mem.distraction = true;
						mem.allowCollisions = FlxObject.NONE;
					}
				}
				return;
			}
			
			if (postSwitchOne) {
				scoreText0.velocity.y = 40;
				scoreText1.velocity.y = 40;
			}
			
			FlxG.collide();
			
			if (counter >= 11 && !postSwitchOne) {
				player.maxVelocity.x = 20;
				player.maxVelocity.y = 50;
				instruct.alpha = 1;
				instruct.text = "That is not good enough. You have to do better.";
			}
			
			if (postSwitchOne)
				face.frame = 0;
			else
				face.frame = Math.floor(counter);
			
			if (counter <= 11 || postSwitchOne) {
				counterText.text = Math.floor(11 - counter).toString();
				if (store.exists)
					storeTitle.text = "This is life. You have negative " + Math.abs(Math.floor(11 - counter)).toString() + " seconds. What would you like to purchase?"
			} else if (counterText.text.length < Math.floor(counter-9) && counterText.text.length < 10) {
				if (counterText.text.length < score) {
					counterText.text += "" + counterText.text.length;
					face.frame = 9 - counterText.text.length;
				}
				else {
					counterText.text += "0";
					face.frame = 9 - score;
				}
			}
			
			player.acceleration.x = 0;
			if (FlxG.keys.LEFT) {
				player.acceleration.x = -player.maxVelocity.x * 4;
				player.facing = FlxObject.LEFT;
				player.play("run");
			}
			if (FlxG.keys.RIGHT) {
				player.acceleration.x = player.maxVelocity.x * 4;
				player.facing = FlxObject.RIGHT;
				player.play("run");
			} else if ( !FlxG.keys.LEFT ) {
				player.play("stand");
			}
			
			if (player.isTouching(FlxObject.FLOOR) || postSwitchOne) {
				if (FlxG.keys.justPressed("UP"))
					player.velocity.y -= player.maxVelocity.y / 1.5;	
			} else {
				player.play("jump");
			}
			
			if (postSwitchOne) {
				
				if (!firstSinkOver && scoreText0.y > FlxG.height) {
					scoreText0.color = 0xffff0000;
					scoreText1.color = 0xff770000;
					firstSinkOver = true;
				}
				
				for (var i:int; i < clouds.length; i++) {
					var cloud:FlxSprite = clouds[i];
					var memo:Memory = memories[Math.min(i, score - 1)];
					if (cloud.velocity.y > 0) {
						if (cloud.y > FlxG.height - 16) {
							cloud.y = FlxG.height - 16;
							cloud.velocity.y = 0;
						}
					} else if (cloud.exists && cloud.overlaps(player)) {
						if (cloud.frame == 0) {
							cloud.frame = 1;
							cloud.velocity.y = 50;
						} else if (memo.frame < 3){
							memo.frame = 3;
						} else if (cloud.frame == 2) {
							store.exists = true;
						}
					} else if (memo.overlaps(player) && memo.frame == 3) {
						memo.frame = 4;
						cloud.frame = 2;
					}
				}
				
				if ( store.exists && FlxG.mouse.justPressed() )
				{
					//footer.text = "justPressed";
					for each (var item:FlxSprite in items) {
						if (item.pixelsOverlapPoint( new FlxPoint(FlxG.mouse.screenX, FlxG.mouse.screenY) ) )
						{
							//footer.text = "overlaps";
							var cost:Number = 10;
							if (item == heart) {
								cost = 18;
							} else if (item == rainbow) {
								cost = 31;
							} else if (item == taco) {
								cost = 5;
							}
							
							if (counter - 10 > cost) {
								footer.text = "The game is now over.";
								counter -= cost;
								scored += Math.floor(cost / 10);
								scoreText0.y = 37;
								scoreText1.y = 37;
								scoreText0.text = "" + scored;
								scoreText1.text = "" + scored;
							} else {
								footer.text = "You do not have enough negative seconds for that.";
							}
						}
					}
				}
			} else {
				if (piece.exists && piece.overlaps(player)) {
					counter = 0;
					score += 1;
					scoreText0.text = scoreText1.text = "" + score;
					player.maxVelocity.x = 80;
					player.maxVelocity.y = 200;
					piece.exists = false;
					if (score < 10) {
						changePiece();	
					}
					else {
						this.memory.inflate = true;
						switchOne = true;
						counter = 0;
					}
				}
			}
			
			
			super.update();
		}
		
		public function onReset():void
		{
			FlxG.switchState(new PlayState());
		}
	}
}